{-# OPTIONS -fglasgow-exts #-}
{-# LANGUAGE OverlappingInstances #-}
{-# LANGUAGE UndecidableInstances #-}

module Control.Parallel.Eden.Grace.IsFunctionType (
    IsFunctionType, HConst, HFuncConstParam, HFuncListParam
)where

data HConst
data HFuncConstParam
data HFuncListParam

class IsFunctionType a b | a -> b
instance TypeCast f HFuncListParam => IsFunctionType ([x] -> y) f
instance TypeCast f HFuncConstParam => IsFunctionType (x -> y) f
instance TypeCast f HConst => IsFunctionType a f

-- literally lifted from the HList library
class TypeCast   a b   | a -> b, b -> a   where typeCast   :: a -> b
class TypeCast'  t a b | t a -> b, t b -> a where typeCast'  :: t->a->b
class TypeCast'' t a b | t a -> b, t b -> a where typeCast'' :: t->a->b
instance TypeCast'  () a b => TypeCast a b where typeCast x = typeCast' () x
instance TypeCast'' t a b => TypeCast' t a b where typeCast' = typeCast''
instance TypeCast'' () a a where typeCast'' _ x  = x